local bs = AceLibrary("Babble-Spell-2.2")
--local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Talismonger = AceLibrary("Talismonger-3.0")
local BH = AceLibrary("Babble-Herbs-2.2")
local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Herbalism")

L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out herbs"] = true,
	["Module description"]  = "Herbalism mapnotes for Cartographer (based on PinPoint by Ammo)",
	["Select all"] = true,
	["Select none"] = true,
	["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,
	["Show minimap icons"] = true,
	["Show herbalism icons on the minimap"] = true,
} end)

L:RegisterTranslations("deDE", function() return {
	["Filter"] = "Filter",
	["Filter out herbs"] = "Kr\195\164uter filtern",
	["Module description"]  = "Kr\195\164uterkunde-Kartennotizen f\195\188r Cartographer (basiert auf PinPoint von Ammo)",  
	["Select all"] = "Alle ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",
	["Icon alpha"] = "Transparenz",
	["Alpha transparency of the icon"] = "Transparenz der Symbole",
	["Icon size"] = "Symbolgr\195\182\195\159e",
	["Size of the icons on the map"] = "Gr\195\182\195\159e der Symbole auf der Weltkarte",
	["Show minimap icons"] = "Minimap-Symbole anzeigen",
	["Show herbalism icons on the minimap"] = "Kr\195\164utersymbole auf der Minimap anzeigen.",
} end)

L:RegisterTranslations("frFR", function() return {
	["Filter"] = "Filtrer",
	["Filter out herbs"] = "Filtrer les plantes",
	["Module description"]  = "Notes d'herboristerie pour Cartographer (bas\195\169 sur PinPoint par Ammo)",
	["Select all"] = "Tout S\195\169lectionner",
	["Select none"] = "Ne rien S\195\169lectionner",
	["Icon alpha"] = "Transparence des ic\195\180nes",
	["Alpha transparency of the icon"] = "D\195\169termine la transparence des ic\195\180nes.",
	["Icon size"] = "Taille des ic\195\180nes",
	["Size of the icons on the map"] = "D\195\169termine la taille des ic\195\180nes sur la carte.",
	["Show minimap icons"] = "Afficher les ic\195\180nes sur la minicarte",
	["Show herbalism icons on the minimap"] = "Affiche les ic\195\180nes des herbes sur la minicarte.",
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "항목 분류",
	["Filter out herbs"] = "약초를 항목에 따라 분류하여 표시합니다.",
	["Module description"] = "맵노트에 약초를 표시합니다.",
	["Select all"] = "모두 선택",
	["Select none"] = "선택 해제",
	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
	["Show minimap icons"] = "미니맵 아이콘 보기",
	["Show herbalism icons on the minimap"] = "미니맵에 약초 아이콘을 표시합니다.",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Filter out herbs"] = "篩檢草藥",	
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",
	["Module description"] = "Module Description",
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtro",
	["Filter out herbs"] = "Filtra las hierbas",  
	["Module description"]  = "Notas de mapa de Herborister\195\173a para Cartographer (basado en PinPoint por Ammo)",
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",
	["Icon alpha"] = "Transparencia de icono",
	["Alpha transparency of the icon"] = "Transparencia de los iconos",
	["Icon size"] = "Tama\195\177o de icono",
	["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
    ["Show minimap icons"] = "Mostrar iconos en minimapa",
    ["Show herbalism icons on the minimap"] = "Muestra los iconos de herborister\195\173a en el minimapa",
} end)

local mod = Cartographer:NewModule("Herbalism", "AceConsole-2.0", "AceEvent-2.0")

local icon_path = "Interface\\Addons\\Cartographer_Herbalism\\Artwork\\"
local icon_list = {
	["Black Lotus"] = "HerbBlackLotus",
	["Blindweed"] = "HerbBlindweed",
	["Briarthorn"] = "HerbBriarthorn",
	["Bruiseweed"] = "HerbBruiseweed",
	["Dreamfoil"] = "HerbDreamfoil",
	["Earthroot"] = "HerbEarthroot",
	["Fadeleaf"] = "HerbFadeleaf",
	["Felweed"] = "HerbFelweed",
	["Firebloom"] = "HerbFirebloom",
	["Goldthorn"] = "HerbGoldthorn",
	["Grave Moss"] = "HerbGraveMoss",
	["Gromsblood"] = "HerbGromsblood",
	["Icecap"] = "HerbIcecap",
	["Kingsblood"] = "HerbKingsblood",
	["Liferoot"] = "HerbLiferoot",
	["Mageroyal"] = "HerbMageroyal",
	["Peacebloom"] = "HerbPeacebloom",
	["Plaguebloom"] = "HerbPlaguebloom",
	["Silverleaf"] = "HerbSilverleaf",
	["Stranglekelp"] = "HerbStranglekelp",
	["Sungrass"] = "HerbSungrass",
	["Swiftthistle"] = "HerbSwiftthistle",
	["Wildvine"] = "HerbKingsblood",
	["Wintersbite"] = "HerbWintersbite",
	["Arthas' Tears"] = "HerbArthasTears",
	["Ghost Mushroom"] = "HerbGhostMushroom",
	["Golden Sansam"] = "HerbGoldenSansam",
	["Khadgar's Whisker"] = "HerbKhadgarsWhisker",
	["Mountain Silversage"] = "HerbMountainSilversage",
	["Purple Lotus"] = "HerbPurpleLotus",
	["Wild Steelbloom"] = "HerbWildSteelbloom",
	["Bloodthistle"] = "HerbGromsblood",
	["Mana Thistle"] = "HerbManaThistle",
	["Netherbloom"] = "HerbNetherbloom",
	["Nightmare Vine"] = "HerbNightmareVine",
	["Ragveil"] = "HerbRagveil",
	["Terocone"] = "HerbTerocone",
	["Flame Cap"] = "HerbFlameCap",
	["Dreaming Glory"] = "HerbDreamingGlory",
	["Fel Lotus"] = "HerbFelLotus",
	["Ancient Lichen"] = "HerbAncientLichen",
}
mod.icon = {}

function mod:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Herbalism")
	Cartographer:RegisterDefaults("Herbalism", "profile", {
		filter = {
			['*'] = true,
		},
		iconAlpha = 1,
		iconScale = 1,
		minicons = true,
	})
	local aceopts = {
		transparency = {
			name = L["Icon alpha"],
			desc = L["Alpha transparency of the icon"],
			type = 'range',
			min = 0.1,
			max = 1,
			step = 0.05,
			isPercent = true,
			get = "GetIconAlpha",
			set = "SetIconAlpha",
			order = 1
		},
		iconSize = {
			name = L["Icon size"],
			desc = L["Size of the icons on the map"],
			type = 'range',
			min = 0.5,
			max = 2,
			step = 0.05,
			isPercent = true,
			get = "GetIconScale",
			set = "SetIconScale",
			order = 1
		},
		minimapIcons = {
			name = L["Show minimap icons"],
			desc = L["Show herbalism icons on the minimap"],
			type = 'toggle',
			set = "ToggleShowingMinimapIcons",
			get = "IsShowingMinimapIcons",
			order = 1,
		},
		toggle = {
			name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
			desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
			type  = 'toggle',
			order = -1,
			get   = function() return Cartographer:IsModuleActive(self) end,
			set   = function() Cartographer:ToggleModuleActive(self) end,
		},
		filter = {
			name = L["Filter"],
			desc = L["Filter out herbs"],
			type = 'group',
			args = {
				all = {
					name = L["Select all"],
					desc = L["Select all"],
					type = 'execute',
					func = function()
						for k in pairs(self.icon) do
							self:ToggleShowingHerb(k, true)
						end
					end,
					order = 1,
				},
				none = {
					name = L["Select none"],
					desc = L["Select none"],
					type = 'execute',
					func = function()
						for k in pairs(self.icon) do
							self:ToggleShowingHerb(k, false)
						end
					end,
					order = 2,
				},
				blank = {
					type = 'header',
					order = 3,
				},
			},
		},
	}
	for k,v in pairs(icon_list) do
		mod.icon[k] = {
			text = BH[k],
			path = icon_path..v,
			width = 12,
			height = 12,
		}
		Talismonger:TrackNode(BH[k])
		aceopts.filter.args[k] = {
			name = BH[k],
			desc = BH[k],
			type = 'toggle',
			get = function()
				return self:IsShowingHerb(k)
			end,
			set = function(value)
				return self:ToggleShowingHerb(k, value)
			end,
		}
	end
	
	Cartographer.options.args["Herbalism"] = {
		name = bs["Herbalism"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args["Herbalism"])
	Cartographer:GetModule('Professions').addons[bs["Herbalism"]] = self
	
	if not Cartographer_HerbalismDB then
		Cartographer_HerbalismDB = {}
	else
		for _, zone in pairs(Cartographer_HerbalismDB) do
			if type(zone) == "table" then
				for id, data in pairs(zone) do
					if data == "Grave moss" then
						data = "Grave Moss"
						zone[id] = data
					end
				end
			end
		end
	end
end

function mod:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end
		Cartographer_Notes:RegisterNotesDatabase('Herbalism', Cartographer_HerbalismDB, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end
	self:RegisterEvent("Talismonger_Node")
end

function mod:Talismonger_Node(spell, what)
	if spell == "Herb Gathering" and BH:HasReverseTranslation(what) then
		self:SetNote(what)
	end
end

function mod:OnDisable()
	self:UnregisterAllEvents()
	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Herbalism')
	end
end

function mod:SetNote(what)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	what = BH.reverse[what]
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 8, "Herbalism", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Herbalism")
end

function mod:OnNoteTooltipRequest(zone, id, herb, minimap)
	Tablet:SetTitle(BH[herb])
	Tablet:SetTitleColor(0, 0.8, 0)	
	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', bs["Herbalism"]
		)
	end
end

function mod:IsNoteHidden(zone, id, herb)
	return not self.db.profile.filter[herb]
end

function mod:IsShowingHerb(herb)
	return self.db.profile.filter[herb]
end

function mod:ToggleShowingHerb(herb, value)
	if value == nil then
		value = not self.db.profile.filter[herb]
	end
	self.db.profile.filter[herb] = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end

function mod:GetIconScale()
	return self.db.profile.iconScale
end

function mod:SetIconScale(value)
	self.db.profile.iconScale = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end

function mod:GetIconAlpha()
	return self.db.profile.iconAlpha
end

function mod:SetIconAlpha(value)
	self.db.profile.iconAlpha = value
	self:ScheduleEvent("CartographerHerbalism_RefreshMap", Cartographer_Notes.RefreshMap, 0, Cartographer_Notes)
end

function mod:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end

function mod:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end

function mod:IsShowingMinimapIcons()
	return self.db.profile.minicons
end

function mod:ToggleShowingMinimapIcons()
	self.db.profile.minicons = not self.db.profile.minicons
end

function mod:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minicons
end

